#ifndef _IPROXY_DYN_LANG_H_
#define _IPROXY_DYN_LANG_H_

#define NSIZE(a) (sizeof(a) / sizeof(a[0]))

typedef struct _IProxyDynLang IProxyDynLang;
typedef struct _DynLangParams DynLangParams;
typedef struct _DynLangParam DynLangParam;


struct _DynLangParam {
    enum {
        TYPE_I,                        // Integer型
        TYPE_L,                        // Long型
        TYPE_F,                        // Float型
        TYPE_D,                        // Double型
        TYPE_S                         // 文字列
    } param_type;
    void* argv;
};
struct _DynLangParams {
    int    argc;                       // DynLangParamの個数
    DynLangParam* param;               // 引数情報
};

struct _IProxyDynLang
{
    void (*FP_proxy_init)(IProxyDynLang*, char* dynFileName);
    void (*FP_proxy_funcall)(IProxyDynLang*, char* funcName, DynLangParams* dynLangParams);
    void (*FP_proxy_funcall2)(IProxyDynLang*, char* className, char* funcName, DynLangParams* dynLangParams);
    void (*FP_proxy_end)(IProxyDynLang*);
#ifdef __cplusplus
    void init(char* dynFileName) {
        this->FP_proxy_init(this, dynFileName);
    };
    void funcall(char* funcName, DynLangParams* dynLangParams) {
        this->FP_proxy_funcall(this, funcName, dynLangParams);
    };
    void funcall2(char* className, char* funcName, DynLangParams* dynLangParams) {
        this->FP_proxy_funcall2(this, className, funcName, dynLangParams);
    };
    void end() {
        this->FP_proxy_end(this);
    }
#endif
};
#ifdef __cplusplus
extern "C" {
#endif
IProxyDynLang* GetProxyDynLang();
void IProxyDynLang_init(IProxyDynLang*, char* dynFileName);
void IProxyDynLang_funcall(IProxyDynLang*, char* funcName, DynLangParams* dynLangParams);
void IProxyDynLang_funcall2(IProxyDynLang*, char* className, char* funcName, DynLangParams* dynLangParams);
void IProxyDynLang_end(IProxyDynLang*);
#ifdef __cplusplus
}
#endif
#endif
